﻿Type=Class
Version=1
B4J=true
@EndOfDesignText@
Private Sub Class_Globals
    'PseudoConsts:
    Private DELIMITER As String = Chr(0x0d) 'CR.
    Private ENCODING As String = "ASCII"
    Private INPUT_STREAM_FALLBACK As Int = 18000
    Private INPUT_STREAM_MAX As Int = 20000 'This can be ineffective if not
                                            'greater than underlying socket
                                            'buffer length (normally 8192
                                            'bytes).
	
	Private mParent As Object
	Private mEventName As String
	Private mIndex As Int
	Private mInput As String
	Private mInUse As Boolean
	Private mLastError As String 
	
	Private sckClient As Socket
	Private astmClient As AsyncStreams
	Private sbAssemStm As StringBuilder 'Assembled input stream buffer.
End Sub

Public Sub Initialize(Parent As Object, EventName As String, Index As Int)
	mParent = Parent
	mEventName = EventName
	mIndex = Index
End Sub

Public Sub getIndex() As Int
	Return mIndex
End Sub

Public Sub getInput() As String 'Valid during Input event.
	Return mInput
End Sub

Public Sub getInUse() As Boolean
	Return mInUse
End Sub

Public Sub getLastError() As String
	Return mLastError
End Sub

Public Sub Close()
	astmClient.Close
	sckClient.Close
	sckClient = Null
	CallSub2(mParent, mEventName & "_Terminated", Me)
	mInUse = False
End Sub

Public Sub NewConnection(NewSocket As Socket)
	mLastError = ""
	sckClient = NewSocket
	sbAssemStm.Initialize
	astmClient.Initialize(sckClient.InputStream, sckClient.OutputStream, "astmClient")
	mInUse = True
End Sub

Public Sub Write(Output As String)
	astmClient.Write(Output.GetBytes(ENCODING))
	astmClient.Write(DELIMITER.GetBytes(ENCODING))
End Sub

Private Sub astmClient_Error()
	mLastError = LastException.Message
	CallSub2(mParent, mEventName & "_Error", Me)
	Close
End Sub

Private Sub astmClient_NewData(Buffer() As Byte)
	Dim Frag As String
	Dim Msgs As String
	Dim Pos As Int
	Dim DelimPos As Int
	
	'Only used to update total bytes received count.
	CallSub2(mParent, mEventName & "_Bytes", Buffer.Length)
	
	Frag = BytesToString(Buffer, 0, Buffer.Length, ENCODING)
	If sbAssemStm.Length > INPUT_STREAM_MAX Then
		'Trim back to length INPUT_STREAM_FALLBACK to deal with a potentially
		'huge message sent to cause us grief.
		'
		'We won't try to be perfect and trim back to a complete message here
		'since it is just text For a human to read, but for programs that
		'exchange data and/or commands this is too simplistic:
		sbAssemStm.Remove(INPUT_STREAM_FALLBACK, sbAssemStm.Length)
	End If
	sbAssemStm.Append(Frag)
	'Check received stream fragment for our message delimiter.  We don't have
	'to check the entire stream.
	If Frag.Contains(DELIMITER) Then
		'We'll now have at least one complete message in the assembled stream.
		Msgs = sbAssemStm.ToString
		'Process all of the complete messages.
		Pos=0
		Do Until DelimPos < 0
			DelimPos = Msgs.IndexOf2(DELIMITER, Pos)
			If DelimPos >= 0 Then
				mInput = Msgs.SubString2(Pos, DelimPos)
				CallSub2(mParent, mEventName & "_Input", Me)
				mInput = ""
				Pos = DelimPos + 1
			End If
		Loop
		'Delete the processed messages from the assembled input stream,
		'reinsert any leftover characters.
		sbAssemStm.Initialize
		sbAssemStm.Append(Msgs.SubString(Pos))
	End If
End Sub

Private Sub astmClient_Terminated()
	Close
End Sub